#include "Calculator.h"
#include "OperandStack.h"
#include "OperatorStack.h"

CCalculator::CCalculator()
{
    m_pOperandStack = new COperandStack;
    m_pOperatorStack = new COperatorStack;
}

CCalculator::~CCalculator()
{
    delete m_pOperandStack;
    delete m_pOperatorStack;
}

void CCalculator::run()
{
    CToken currentToken;
    double left, right;
    char op;

    printf("пJB⦡, ҦpG1 + 2 *3/4 =\n");

    while ((currentToken=nextToken()).type != voidT)
    {
        if (currentToken.type == operandT)
            m_pOperandStack->push(currentToken.operand);
        else if (currentToken.type == operatorT)
        {
            while (m_pOperatorStack->precedenceIsNotLowerThan(currentToken.opcode))
            {
                right = m_pOperandStack->pop();
                left = m_pOperandStack->pop();
                op = m_pOperatorStack->pop();
                switch (op)
                {
                case '+':
                    m_pOperandStack->push(left+right);
                    break;
                case '-':
                    m_pOperandStack->push(left-right);
                    break;
                case '*':
                    m_pOperandStack->push(left*right);
                    break;
                case '/':
                    m_pOperandStack->push(left/right);
                    break;
                default:
                    printf("Calculator::run() illegal operator on the stack\n");
                    break;
                }
            }
            if (currentToken.opcode == '=')
            {
                printf("Result is %lf\n", m_pOperandStack->pop());
                break;
            }
            else
                m_pOperatorStack->push(currentToken.opcode);
        }
    }

    if (m_pOperatorStack->IsEmpty())
        printf("Operator Stack is empty\n");
    else
        printf("Operator Stack is not empty\n");

    if (m_pOperandStack->IsEmpty())
        printf("Operand Stack is empty\n");
    else
        printf("Operand Stack is not empty\n");
}

CToken CCalculator::nextToken()
{
    CToken t;
    char c, buf[100];
    int i;
    double x, y;
    
    if (skipSpace() == 0)
    {
        t.type = voidT;
        return t; /* end of data */
    }
        
    c = getc(stdin);
    if (validOperator(c))
    {
        t.type = operatorT;
        t.opcode = c;
        return t;
    }

    i = 0;
    buf[i++] = c;
    while (validOperand(c=getchar()))
    {
        buf[i++] = c;
        if (i>=100)
        {
            printf("ƭȦƤW 100!\n");
            t.type = voidT;
            return t; 
        }
    }
    buf[i++] = 0;
    ungetc(c, stdin);
    i = sscanf(buf, "%lf", &x, &y);
    if (i != 1)
    {
        printf("BƭȪܿ~!\n");
        t.type = voidT;
        return t; 
    }
    t.type = operandT;
    t.operand = x;
    return t;
}

int CCalculator::skipSpace()
{
    int c;
    while ((c=getc(stdin)) != EOF)
    {
        if ((c != ' ')&&(c != '\t')&&(c != '\n'))
        {
            ungetc(c, stdin);
            return 1;
        }
    }
    return 0; /* end of data */
}

int CCalculator::validOperator(char opr)
{
    if ((opr == '+')||
        (opr == '-')||
        (opr == '*')||
        (opr == '/')||
        (opr == '='))
        return 1;
    else
        return 0;
}

int CCalculator::validOperand(char c)
{
    if (((c>='0')&&(c<='9'))||(c=='.'))
        return 1;
    else
        return 0;
}

void main()
{
    CCalculator theApp;
    theApp.run();
}
