#ifndef CALCULATOR_H
#define CALCULATOR_H

#include <stdio.h>

#include "symbols.h"

enum TokenType {operatorT=0, operandT, voidT};

struct CToken
{
    TokenType type;
    union
    {
        char opcode;
        double operand;
    };
};

#include "OperandStack.h"
#include "OperatorStack.h"

class CCalculator
{
public:
    CCalculator();
    ~CCalculator();
    void run();

private:
    CToken nextToken();
    int skipSpace();
    int validOperator(char opr);
    int validOperand(char c);
    COperandStack *m_pOperandStack;
    COperatorStack *m_pOperatorStack;
};

#endif