#include "OperatorStack.h"
#include <stdio.h>  // printf
#include <stdlib.h> // exit

COperatorStack::COperatorStack() : m_top(NULL)
{
}

COperatorStack::~COperatorStack()
{
    clear();
}

void COperatorStack::clear()
{
    while (m_top != NULL)
        pop();
}

void COperatorStack::push(char op)
{
    if (m_top == NULL)
        m_top = new COperatorNode(op);
    else
    {
        COperatorNode *ptrTmp = m_top;
        m_top = new COperatorNode(op);
        m_top->next = ptrTmp;
    }
}

char COperatorStack::pop()
{
    if (m_top == NULL)
    {
        printf("OperatorStack::pop(), empty operator stack\n");
        exit(1);
        return 0; // dummy
    }
    else
    {
        COperatorNode *ptrTmp = m_top;
        char result = ptrTmp->opcode;
        m_top = m_top->next;
        delete ptrTmp;
        return result;
    }
}

BOOL COperatorStack::precedenceIsNotLowerThan(char op)
{
    if (m_top == NULL)
        return FALSE;
    else
    {
        if (numericOrder(op) <= numericOrder(m_top->opcode))
            return TRUE;
        else
            return FALSE;
    }
}

int COperatorStack::numericOrder(char op)
{
    switch (op)
    {
    case '=':
        return 0;
    case '+':
    case '-':
        return 1;
    case '*':
    case '/':
        return 2;
    default:
        printf("COperatorStack::numericOrder(), illegal operator\n");
        exit(1);
        return -1; // dummy
    }
}

BOOL COperatorStack::IsEmpty()
{
    return (m_top == NULL);
}

